unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, ExtCtrls;

type

  tmyThread=class(TThread)
     private
       s:string;
     protected
      procedure execute; override;
      procedure send;
     end;
  TForm1 = class(TForm)
    IdTCPClient1: TIdTCPClient;
    Edit1: TEdit;
    Button2: TButton;
    ListBox1: TListBox;
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    pt:tmyThread;
    shafts,levels,levelheight,maxaccel,maxspeed,maxdev,maxonboard:integer;
    vytahy:array of record
      meter,level,speed:integer;//vlastnosti
      kam_miri:integer;
    end;
  public
    procedure event(s:string);
    procedure sendmsg(s:string);
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
begin
  IdTCPClient1.WriteLn(Edit1.Text+#13#10);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 try
  IdTCPClient1.Connect;
  pt:=tmyThread.Create(false);
 except
  showmessage('nemuzu se pripojit k serveru!!');
  close;
 end;
end;

procedure tmyThread.execute;
begin
  while not Terminated do
  begin
     if Form1.IdTCPClient1.Connected then
     begin
      s:=form1.IdTCPClient1.ReadLn(#13#10);
      Synchronize(send);
     end;
  end;
end;

procedure TForm1.event(s:string);
var prikaz:string;
    param:array of string;
    position,code,index:integer;
begin
  ListBox1.Items.Add(s);
  position:=pos(' ',s);
  if position=0 then
    position:=length(s)+1;
  prikaz:=copy(s,1,position-1);
  s:=copy(s,position+1,length(s)-position+1);
  while s<>'' do
  begin
       setlength(param,high(param)+2);
       position:=pos(' ',s);
       if position=0 then
         position:=length(s)+1;
       param[high(param)]:=copy(s,1,position-1);
       s:=copy(s,position+1,length(s)-position+1);
  end;
  if prikaz='shafts' then
  begin
     val(param[0],shafts,code);
     setlength(vytahy,shafts);
  end;
// pri resetu (vlastnosti domu)
  if prikaz='levelheight' then
     val(param[0],levelheight,code);
  if prikaz='maxaccel' then
     val(param[0],maxaccel,code);
  if prikaz='maxspeed ' then
     val(param[0],maxspeed,code);
  if prikaz='maxdev' then
     val(param[0],maxdev,code);
  if prikaz='maxonboard' then
     val(param[0],maxonboard,code);
   if prikaz='levels' then
     val(param[0],levels,code);
  if prikaz='level' then
    sendmsg('shaftinfo '+param[0]+' '+param[1]);
// tlacitka + svetelkka
  if prikaz='levelbuttonup' then
  begin
       sendmsg('indiupon '+param[0]);
       sendmsg('close 0');
       sendmsg('floor 0 '+param[0]);
       sendmsg('open 0');
  end;
  if prikaz='levelbuttondn' then
  begin
    sendmsg('indidnon '+param[0]);
    sendmsg('floor 0 '+param[0]);
    sendmsg('open 0');
  end;
  if prikaz='cabinbutton' then
  begin
    sendmsg('indion '+param[0]+' '+param[1]);
    sendmsg('close '+param[0]);
    sendmsg('floor '+param[0]+' '+param[1]);
    sendmsg('open '+param[0]);
  end;

// pro vytahy
  if prikaz='speed' then
  begin
     val(param[0],index,code);
     if index>shafts-1 then
        setlength(vytahy,index+1);
     val(param[1],vytahy[index].speed,code);
  end;
  if prikaz='meter' then
  begin
     val(param[0],index,code);
     if index>shafts-1 then
        setlength(vytahy,index+1);
     val(param[1],vytahy[index].meter,code);
  end;
  if prikaz='level' then
  begin
     val(param[0],index,code);
     if index>shafts-1 then
        setlength(vytahy,index+1);
     val(param[1],vytahy[index].level,code);
     sendmsg('shaftinfo '+param[0]+' '+param[1]);
  end;
end;

procedure tmyThread.send;
begin
     form1.event(s);
end;

procedure TForm1.sendmsg(s:string);
begin
   IdTCPClient1.WriteLn(s+#13#10);
end;

end.
